-------------------
-- SRAM verstion2
-------------------

---- Description --------
-- entity SRAM
-- architecture ARC of SRAM

--------------------------

---- Notes -------------------------------------------
-- 2007.01.18
-- 낢ƃVOiprocess̊O֏oĂ݂B
-- CLKM0,CLKM1͂ŐȂقǂH
-- 2006.12.08
---- B̓RsyH
---- ł{Iɉ̂ŁB
---- constant`̓r܂ŁcB̂B
----
-- Verstion1̋L^
-- 2006.10.26 
---- ƏĂ݂BSRAMւ̗v󂯎āA
---- SRAMւ̗voĤB

------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity SRAM is
    port(
        CLK : in std_logic;                         -- clock 50MHz
        RESET : in std_logic;                       -- reset

        MODE : in std_logic;                       -- read/write mode
        ADDR : in std_logic_vector(19 downto 0);    -- read/write address
        --AOUT : out std_logic_vector(19 downto 0);   -- current data address
        RDATA : out std_logic_vector(31 downto 0);  -- read data
        RP : out std_logic_vector(3 downto 0);      -- read parity
        WDATA : in std_logic_vector(31 downto 0);   -- write data
        WP : in std_logic_vector(3 downto 0);       -- write parity
        -- to SRAM
        RW : out std_logic; -- read or write
        IO : inout std_logic_vector(31 downto 0);  -- IO data
        IOP : inout std_logic_vector(3 downto 0);  -- IO parity
        AA : out std_logic_vector(19 downto 0);    -- address
        -- to SRAM(constant)
--        CLKM0,CLKM1 : out std_logic;                      -- SRAM clock
        BW : out std_logic_vector(3 downto 0);
        CEH1X,CEL1X,CE2,CE2X : out std_logic;      -- chip select
        OEX,CENX,ADVLD : out std_logic;
        LBOX : out std_logic;
        ZZ : out std_logic);

end SRAM;


architecture ARC of SRAM is
    signal MBUF0,MBUF1 : std_logic;                           -- mode buffer
    signal WBUF0,WBUF1 : std_logic_vector(31 downto 0);       -- write data buffer
    --signal WPBUF0,WPBUF1 : std_logic_vector(3 downto 0);      -- write parity buffer
    --signal ABUF0,ABUF1,ABUF2 : std_logic_vector(19 downto 0); -- address buffer

begin

    -- constant
    BW <= "0000";
    CEH1X <= '1' when (RESET = '1') else '0';
    CEL1X <= '1' when (RESET = '1') else '0';
    CE2 <= '0' when (RESET = '1') else '1';
    CE2X <= '1' when (RESET = '1') else '0';
    OEX <= '1' when (RESET = '1') else '0';
    CENX <= '0';
    ADVLD <= '0';
    LBOX <= '1';
    ZZ <= '0';

    -- to sram(write data)
    IO <= (others => 'Z') when MBUF1 = '1' else WBUF1;
--    IOP <= (others => 'Z') when MBUF1 = '1' else WPBUF1;
    IOP <= (others => 'Z') when MBUF1 = '1' else "0000";

    -- to sram(addr & rw)
    AA <= ADDR;
    RW <= MODE;
    -- from sram(read data)
    RDATA <= IO;
    RP    <= IOP;


    process(CLK,RESET)
    begin
        if RESET = '1' then

            -- signal
            MBUF0 <= '1';
            MBUF1 <= '1';
            WBUF0 <= (others => '0');
            WBUF1 <= (others => '0');
--            WPBUF0 <= (others => '0');
--            WPBUF1 <= (others => '0');

            -- to sram
--            AA <= (others => '0');
--            IO <= (others => 'Z');
--            IOP <= (others => 'Z');

        elsif CLK'event and CLK = '1' then

            -- rw mode buffer
            MBUF0 <= MODE;
            MBUF1 <= MBUF0;

            -- write data buffer
            WBUF0  <= WDATA;
            WBUF1  <= WBUF0;
--            WPBUF0 <= WP;
--            WPBUF1 <= WPBUF0;

        end if;
    end process;
end ARC;

